stages:
 - eslint
 - test
 - report
 - publish
 - release

include: .perso.yml

eslint-job:
    stage: eslint
    extends: .node-job
    variables:
        NPM_SCRIPT: lint-report
    script:
        - npm run lint-report
    artifacts:
        paths:
            - lint-report.json
    
test-job:
    stage: test
    script:
        - npm run test
    extends: .node-job
    variables:
        NPM_SCRIPT: test
    cache:
        key:
            files:
                - package-lock.json
        paths:
            - node_modules/
    artifacts:
        when: always
        reports: 
            junit: test-results.xml
    dependencies: []

report-job:
    stage: report
    image:
        name: itisfoundation/jq:v0
        entrypoint: [""]

    script: 
        - cat lint-report.json | jq
        - echo VERSION=$(jq -r .version package.json) > vars.env
    dependencies: [eslint-job]
    artifacts:
        when: always
        reports:
            dotenv: vars.env

publish-job:
    stage: publish
    extends: .node-job
    script:
        - echo "@uness:registry=https://${CI_SERVER_HOST}/api/v4/projects/${CI_PROJECT_ID}/packages/npm/" > .npmrc
        - echo "//${CI_SERVER_HOST}/api/v4/projects/${CI_PROJECT_ID}/packages/npm/:_authToken=${CI_JOB_TOKEN}" >> .npmrc
        - npm publish
    rules:
        - if: $CI_COMMIT_TAG
        - when: never
    needs:
        - eslint-job
        - test-job

gitlab-release:
    stage: release
    image: registry.gitlab.com/gitlab-org/release-cli:latest
    script: "echo release running"
    release:
        tag_name: $VERSION
        name: 'Release ${VERSION}'
        description: 'my release ${VERSION}'
    rules:
        - if: $CI_COMMIT_BRANCH == 'main'
        - when: never